(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/forms'), require('@angular/core'), require('@angular/common'), require('@anjuna/core')) :
    typeof define === 'function' && define.amd ? define('@anjuna/angular-core', ['exports', '@angular/forms', '@angular/core', '@angular/common', '@anjuna/core'], factory) :
    (factory((global.anjuna = global.anjuna || {}, global.anjuna['angular-core'] = {}),global.ng.forms,global.ng.core,global.ng.common,global.core));
}(this, (function (exports,forms,i0,common,core) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var TENANT_TIMEZONE_STRING = new i0.InjectionToken('TenantTimezoneString');
    /** @type {?} */
    var TENANT_MERIDIEM = new i0.InjectionToken('TenantMeridiem');
    /** @type {?} */
    var TIMEZONE_OVERRIDE = new i0.InjectionToken('TimezoneOverride');
    /** @type {?} */
    var MOMENT = new i0.InjectionToken('MomentJs');

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /* Note: Typings of 'any' in this file refer to Moment.
             The Moment type does not come without the full weight of Moment.js, so it was intentionally left out. */
    var MomentDateAdapter = /** @class */ (function () {
        function MomentDateAdapter(_moment, _locale, _timezone) {
            this._moment = _moment;
            this._locale = _locale;
            this._timezone = _timezone;
            this.moment = _moment;
            this.timezone = _timezone;
            if (this.moment) {
                this.moment.locale(this._locale);
                if (this.timezone) {
                    this.moment.tz.setDefault(this.timezone);
                }
                else {
                    console.warn('Timezone is not set, is defaulting to system timezone. TIMEZONE_OVERRIDE may be set at the Module level.');
                }
            }
            else {
                console.error('Package "moment" has not been installed. Please either install "moment" or use the NativeDateAdapter.');
            }
        }
        /**
         * @param {?} year
         * @param {?} month
         * @return {?}
         */
        MomentDateAdapter.prototype.dayOfFirst = /**
         * @param {?} year
         * @param {?} month
         * @return {?}
         */
            function (year, month) {
                /** @type {?} */
                var adjusted = this.handleMonthAdjustment(year, month);
                return this.moment([adjusted.year, adjusted.month, 1]).day();
            };
        /**
         * @param {?} year
         * @param {?} month
         * @return {?}
         */
        MomentDateAdapter.prototype.daysInMonth = /**
         * @param {?} year
         * @param {?} month
         * @return {?}
         */
            function (year, month) {
                /** @type {?} */
                var adjusted = this.handleMonthAdjustment(year, month);
                return this.moment([adjusted.year, adjusted.month]).daysInMonth();
            };
        /**
         * @param {?} evalDate
         * @param {?} dateRangeParams
         * @return {?}
         */
        MomentDateAdapter.prototype.isDisabled = /**
         * @param {?} evalDate
         * @param {?} dateRangeParams
         * @return {?}
         */
            function (evalDate, dateRangeParams) {
                if (!dateRangeParams || (!dateRangeParams.minDate && !dateRangeParams.maxDate)) {
                    return false;
                }
                /** @type {?} */
                var dayIsBeforeMinDate = this.moment(evalDate).isBefore(this.moment(dateRangeParams.minDate), 'day');
                /** @type {?} */
                var dayIsAfterMaxDate = this.moment(evalDate).isAfter(this.moment(dateRangeParams.maxDate), 'day');
                return dayIsBeforeMinDate || dayIsAfterMaxDate;
            };
        /**
         * @param {?} year
         * @param {?} month
         * @return {?}
         */
        MomentDateAdapter.prototype.getMonthInfo = /**
         * @param {?} year
         * @param {?} month
         * @return {?}
         */
            function (year, month) {
                /** @type {?} */
                var adjusted = this.handleMonthAdjustment(year, month);
                return new Date(this.moment([adjusted.year, adjusted.month, 15]));
            };
        /**
         * @param {?} date
         * @return {?}
         */
        MomentDateAdapter.prototype.month = /**
         * @param {?} date
         * @return {?}
         */
            function (date) {
                return this.moment(date).month();
            };
        /**
         * @param {?=} year
         * @param {?=} month
         * @param {?=} day
         * @return {?}
         */
        MomentDateAdapter.prototype.newDateFromArray = /**
         * @param {?=} year
         * @param {?=} month
         * @param {?=} day
         * @return {?}
         */
            function (year, month, day) {
                if (month === void 0) {
                    month = 0;
                }
                if (day === void 0) {
                    day = 1;
                }
                return new Date(this.moment([year, month, day]));
            };
        /**
         * @param {?=} value
         * @return {?}
         */
        MomentDateAdapter.prototype.newDateFromValue = /**
         * @param {?=} value
         * @return {?}
         */
            function (value) {
                if (!value) {
                    return new Date();
                }
                else if (value instanceof Date) {
                    return new Date(this.moment(value));
                }
                else {
                    return new Date(value);
                }
            };
        /**
         * @param {?} date
         * @return {?}
         */
        MomentDateAdapter.prototype.prepHeaderDate = /**
         * @param {?} date
         * @return {?}
         */
            function (date) {
                return this.moment(date).locale(this.formatterLanguage || this._locale).format('ddd, MMM D');
            };
        /**
         * @param {?} date
         * @return {?}
         */
        MomentDateAdapter.prototype.prepHeaderYear = /**
         * @param {?} date
         * @return {?}
         */
            function (date) {
                return this.moment(date).locale(this.formatterLanguage || this._locale).format('YYYY');
            };
        /**
         * @param {?} _calendarDay
         * @param {?} _comparator
         * @return {?}
         */
        MomentDateAdapter.prototype.sameDay = /**
         * @param {?} _calendarDay
         * @param {?} _comparator
         * @return {?}
         */
            function (_calendarDay, _comparator) {
                /** @type {?} */
                var calendarDay = this.moment([_calendarDay.year, _calendarDay.month, _calendarDay.day]);
                /** @type {?} */
                var comparator = this.moment(_comparator);
                return calendarDay.isSame(comparator, 'day');
            };
        /**
         * @param {?} date
         * @return {?}
         */
        MomentDateAdapter.prototype.year = /**
         * @param {?} date
         * @return {?}
         */
            function (date) {
                return this.moment(date).year();
            };
        /**
         * @return {?}
         */
        MomentDateAdapter.prototype.weekdays = /**
         * @return {?}
         */
            function () {
                return this.moment.weekdays();
            };
        /**
         * @return {?}
         */
        MomentDateAdapter.prototype.months = /**
         * @return {?}
         */
            function () {
                return this.moment.monthsShort();
            };
        /**
         * @private
         * @param {?} year
         * @param {?} month
         * @return {?}
         */
        MomentDateAdapter.prototype.handleMonthAdjustment = /**
         * @private
         * @param {?} year
         * @param {?} month
         * @return {?}
         */
            function (year, month) {
                if (month > 11) {
                    month = month - 12;
                    year++;
                }
                else if (month < 0) {
                    month = month + 12;
                    year--;
                }
                return { year: year, month: month };
            };
        /**
         * @param {?} input
         * @return {?}
         */
        MomentDateAdapter.prototype.prepDateStringOutput = /**
         * @param {?} input
         * @return {?}
         */
            function (input) {
                return (input) ? this.moment(this.processDateInput(input)).format('l') : '';
            };
        /**
         * @param {?} input
         * @return {?}
         */
        MomentDateAdapter.prototype.processDateInput = /**
         * @param {?} input
         * @return {?}
         */
            function (input) {
                if (!input) {
                    return null;
                }
                if (input && this.moment(input, 'L', this._locale).isValid()) {
                    /** @type {?} */
                    var timezone = this.timezone || this.moment.tz.guess();
                    return this.moment(input, 'L', this._locale).tz(timezone).startOf('day').toDate();
                }
                return new Date('false');
            };
        MomentDateAdapter.decorators = [
            { type: i0.Injectable }
        ];
        /** @nocollapse */
        MomentDateAdapter.ctorParameters = function () {
            return [
                { type: undefined, decorators: [{ type: i0.Inject, args: [MOMENT,] }] },
                { type: String, decorators: [{ type: i0.Optional }, { type: i0.Inject, args: [i0.LOCALE_ID,] }] },
                { type: String, decorators: [{ type: i0.Optional }, { type: i0.Inject, args: [TIMEZONE_OVERRIDE,] }] }
            ];
        };
        return MomentDateAdapter;
    }());
    /**
     * @param {?} MOMENT_
     * @param {?=} locale
     * @param {?=} timezone
     * @return {?}
     */
    function getMomentDateAdapter(MOMENT_, locale, timezone) {
        return new MomentDateAdapter(MOMENT_, locale, timezone);
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var STANDARD_LOCALES = {
        'en-US': 'M/d/yyyy',
        'sw-KE': 'M/d/yyyy',
        'en-ZW': 'M/d/yyyy',
        'en-PH': 'M/d/yyyy',
        'rw-RW': 'M/d/yyyy',
        'moh-CA': 'M/d/yyyy',
        'fil-PH': 'M/d/yyyy',
        'ne-NP': 'M/d/yyyy',
        'es-US': 'M/d/yyyy',
        'sq-AL': 'yyyy/M/d',
        'bg-BG': 'yyyy/M/d',
        'sr-BA': 'yyyy/M/d',
        'fr-CA': 'yyyy/M/d',
        'zh-CN': 'yyyy/M/d',
        'zh-HK': 'yyyy/M/d',
        'hu-HU': 'yyyy/M/d',
        'ja-JP': 'yyyy/M/d',
        'ko-KR': 'yyyy/M/d',
        'lt-LT': 'yyyy/M/d',
        'sv-SE': 'yyyy/M/d',
        'zh-TW': 'yyyy/M/d',
        'en-ZA': 'yyyy/M/d'
    };
    /**
     * @abstract
     * @template T
     */
    var /**
     * @abstract
     * @template T
     */ DateAdapter = /** @class */ (function () {
        function DateAdapter() {
        }
        return DateAdapter;
    }());
    // Default adapter, will accept String or Native Date
    var NativeDateAdapter = /** @class */ (function () {
        function NativeDateAdapter(_locale) {
            this._locale = _locale;
            this.languageCode = (_locale) ? _locale.split('-')[0] : 'en';
        }
        /**
         * @param {?} year
         * @param {?} month
         * @return {?}
         */
        NativeDateAdapter.prototype.dayOfFirst = /**
         * @param {?} year
         * @param {?} month
         * @return {?}
         */
            function (year, month) {
                return new Date(year, month, 1).getDay();
            };
        /**
         * @param {?} year
         * @param {?} month
         * @return {?}
         */
        NativeDateAdapter.prototype.daysInMonth = /**
         * @param {?} year
         * @param {?} month
         * @return {?}
         */
            function (year, month) {
                return new Date(year, month + 1, 0).getDate();
            };
        /**
         * @param {?} evalDate
         * @param {?} dateRangeParams
         * @return {?}
         */
        NativeDateAdapter.prototype.isDisabled = /**
         * @param {?} evalDate
         * @param {?} dateRangeParams
         * @return {?}
         */
            function (evalDate, dateRangeParams) {
                if (!dateRangeParams) {
                    return false;
                }
                /** @type {?} */
                var dayIsBeforeMinDate = (dateRangeParams.minDate) ? evalDate < dateRangeParams.minDate : false;
                /** @type {?} */
                var dayIsAfterMaxDate = (dateRangeParams.maxDate) ? evalDate > dateRangeParams.maxDate : false;
                return dayIsBeforeMinDate || dayIsAfterMaxDate;
            };
        /**
         * @param {?} year
         * @param {?} month
         * @return {?}
         */
        NativeDateAdapter.prototype.getMonthInfo = /**
         * @param {?} year
         * @param {?} month
         * @return {?}
         */
            function (year, month) {
                return new Date(year, month, 15);
            };
        /**
         * @param {?} date
         * @return {?}
         */
        NativeDateAdapter.prototype.month = /**
         * @param {?} date
         * @return {?}
         */
            function (date) {
                return date.getMonth();
            };
        /**
         * @param {?=} year
         * @param {?=} month
         * @param {?=} day
         * @return {?}
         */
        NativeDateAdapter.prototype.newDateFromArray = /**
         * @param {?=} year
         * @param {?=} month
         * @param {?=} day
         * @return {?}
         */
            function (year, month, day) {
                return new Date(year, month, day);
            };
        /**
         * @param {?=} value
         * @return {?}
         */
        NativeDateAdapter.prototype.newDateFromValue = /**
         * @param {?=} value
         * @return {?}
         */
            function (value) {
                return (value) ? new Date(value) : new Date();
            };
        /**
         * @param {?} date
         * @return {?}
         */
        NativeDateAdapter.prototype.prepHeaderDate = /**
         * @param {?} date
         * @return {?}
         */
            function (date) {
                return localize(this.languageCode, date, 'EEE, MMM d');
            };
        /**
         * @param {?} date
         * @return {?}
         */
        NativeDateAdapter.prototype.prepHeaderYear = /**
         * @param {?} date
         * @return {?}
         */
            function (date) {
                return localize(this.languageCode, date, 'yyyy');
            };
        /**
         * @param {?} _calendarDay
         * @param {?} _comparator
         * @return {?}
         */
        NativeDateAdapter.prototype.sameDay = /**
         * @param {?} _calendarDay
         * @param {?} _comparator
         * @return {?}
         */
            function (_calendarDay, _comparator) {
                return _calendarDay.day === _comparator.getDate()
                    && _calendarDay.month === _comparator.getMonth()
                    && _calendarDay.year === _comparator.getFullYear();
            };
        /**
         * @param {?} date
         * @return {?}
         */
        NativeDateAdapter.prototype.year = /**
         * @param {?} date
         * @return {?}
         */
            function (date) {
                return date.getFullYear();
            };
        /**
         * @return {?}
         */
        NativeDateAdapter.prototype.weekdays = /**
         * @return {?}
         */
            function () {
                return getWeekdays(this.languageCode);
            };
        /**
         * @return {?}
         */
        NativeDateAdapter.prototype.months = /**
         * @return {?}
         */
            function () {
                return getMonths(this.languageCode);
            };
        /**
         * @param {?} input
         * @return {?}
         */
        NativeDateAdapter.prototype.prepDateStringOutput = /**
         * @param {?} input
         * @return {?}
         */
            function (input) {
                return (input) ? new Date(this.processDateInput(input)).toLocaleDateString(this._locale) : '';
            };
        /**
         * @param {?} input
         * @return {?}
         */
        NativeDateAdapter.prototype.processDateInput = /**
         * @param {?} input
         * @return {?}
         */
            function (input) {
                if (!input) {
                    return null;
                }
                if (typeof input === 'string') {
                    /** @type {?} */
                    var dateSegments = parseInput(input, this._locale);
                    if (Array.isArray(dateSegments.splitDate) && dateSegments.splitDate.length === 3 && dateSegments.year) {
                        return new Date(parseInt(dateSegments.year, 10), parseInt(dateSegments.month, 10) - 1, parseInt(dateSegments.day, 10));
                    }
                    else {
                        return new Date(input);
                    }
                }
                else {
                    return input;
                }
            };
        /** @nocollapse */
        NativeDateAdapter.ctorParameters = function () {
            return [
                { type: String, decorators: [{ type: i0.Optional }, { type: i0.Inject, args: [i0.LOCALE_ID,] }] }
            ];
        };
        return NativeDateAdapter;
    }());
    /**
     * @param {?} lang
     * @return {?}
     */
    function getWeekdays(lang) {
        /** @type {?} */
        var weekdays = [];
        for (var i = 0; i < 7; i++) {
            /** @type {?} */
            var date = new Date();
            /** @type {?} */
            var testDate = date.setDate(date.getDate() - date.getDay() + i);
            weekdays.push(localize(lang, new Date(testDate), 'EEE'));
        }
        return weekdays;
    }
    /**
     * @param {?} lang
     * @return {?}
     */
    function getMonths(lang) {
        /** @type {?} */
        var months = [];
        for (var i = 0; i < 12; i++) {
            /** @type {?} */
            var testDate = new Date().setMonth(i);
            months.push(localize(lang, new Date(testDate), 'MMM'));
        }
        return months;
    }
    /**
     * @param {?=} _languageCode
     * @param {?=} date
     * @param {?=} format
     * @return {?}
     */
    function localize(_languageCode, date, format) {
        if (_languageCode === void 0) {
            _languageCode = 'en';
        }
        /** @type {?} */
        var pipe = new common.DatePipe(_languageCode);
        return pipe.transform(date, format);
    }
    /* Currently only support shortDate strings (with non-alphanumeric separators) of:
        {
            Month-Day-Year: if included in STANDARD_LOCALES,
            Year-Month-Day: if included in STANDARD_LOCALES,
            Day-Month-Year: for all locales outside of STANDARD_LOCALES
        }
     */
    /**
     * @param {?} input
     * @param {?} locale
     * @return {?}
     */
    function parseInput(input, locale) {
        /** @type {?} */
        var format = STANDARD_LOCALES[locale];
        // Covers case of partial locale code provided
        if (!format) {
            /** @type {?} */
            var localeKey = Object.keys(STANDARD_LOCALES).find(function (key) { return key.includes(locale); });
            format = STANDARD_LOCALES[localeKey];
        }
        // Split string on any non-alphanumeric characters, not including spaces
        /** @type {?} */
        var regexSplit = input.split(/[^\w\s]+/g).filter(Boolean);
        // Parse digit-only string, or use the regexSplit value
        /** @type {?} */
        var splitDate = (regexSplit.length <= 1 && input.length === 8) ? parseDigitOnlyDate(input, format) : regexSplit;
        /** @type {?} */
        var dateSegments = {
            splitDate: splitDate,
            year: '',
            month: '',
            day: ''
        };
        /** @type {?} */
        var splitDateCp = splitDate.slice(0);
        // Set year
        dateSegments.year = setYearSegment(splitDateCp);
        // Set Day and Month
        Object.assign(dateSegments, setMonthAndDaySegments(splitDateCp, format));
        return dateSegments;
    }
    /**
     * @param {?} splitDateArray
     * @return {?}
     */
    function setYearSegment(splitDateArray) {
        // Find year
        /** @type {?} */
        var year = splitDateArray.find(function (segment) { return segment.length === 4; });
        // Remove year from working array
        /** @type {?} */
        var yearIndex = splitDateArray.indexOf(year);
        splitDateArray.splice(yearIndex, 1);
        return year;
    }
    /**
     * @param {?} splitDateArray
     * @param {?} format
     * @return {?}
     */
    function setMonthAndDaySegments(splitDateArray, format) {
        /** @type {?} */
        var segments = {
            day: '',
            month: ''
        };
        // See if we can determine which segment is the days segment
        /** @type {?} */
        var assumedDay = splitDateArray.find(function (segment) { return parseInt(segment, 10) > 12; });
        if (assumedDay) {
            segments.day = assumedDay;
            /** @type {?} */
            var dayIndex = splitDateArray.indexOf(assumedDay);
            splitDateArray.splice(dayIndex, 1);
            segments.month = splitDateArray[0];
            // Otherwise, make a reasonable guess
        }
        else {
            switch (format) {
                case 'M/d/yyyy':
                case 'yyyy/M/d':
                    segments.month = splitDateArray[0];
                    segments.day = splitDateArray[1];
                    break;
                // Assume 'dd/MM/yyyy' for anything else
                default:
                    segments.month = splitDateArray[1];
                    segments.day = splitDateArray[0];
                    break;
            }
        }
        return segments;
    }
    /**
     * @param {?} input
     * @param {?} format
     * @return {?}
     */
    function parseDigitOnlyDate(input, format) {
        /** @type {?} */
        var splitDate;
        switch (format) {
            case 'yyyy/M/d':
                splitDate = [
                    input.slice(0, 4),
                    input.slice(4, 6),
                    input.slice(6)
                ];
                break;
            // Assume 'dd/MM/yyyy' or 'M/d/yyyy' for anything else
            default:
                splitDate = [
                    input.slice(0, 2),
                    input.slice(2, 4),
                    input.slice(4)
                ];
                break;
        }
        return splitDate;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var UTCDateAdapter = /** @class */ (function () {
        function UTCDateAdapter(_locale) {
            this._locale = _locale;
            this.languageCode = (_locale) ? _locale.split('-')[0] : 'en';
        }
        /**
         * @param {?} year
         * @param {?} month
         * @return {?}
         */
        UTCDateAdapter.prototype.dayOfFirst = /**
         * @param {?} year
         * @param {?} month
         * @return {?}
         */
            function (year, month) {
                return new Date(year, month, 1).getDay();
            };
        /**
         * @param {?} year
         * @param {?} month
         * @return {?}
         */
        UTCDateAdapter.prototype.daysInMonth = /**
         * @param {?} year
         * @param {?} month
         * @return {?}
         */
            function (year, month) {
                return new Date(year, month + 1, 0).getDate();
            };
        /**
         * @param {?} evalDate
         * @param {?} dateRangeParams
         * @return {?}
         */
        UTCDateAdapter.prototype.isDisabled = /**
         * @param {?} evalDate
         * @param {?} dateRangeParams
         * @return {?}
         */
            function (evalDate, dateRangeParams) {
                if (!dateRangeParams) {
                    return false;
                }
                /** @type {?} */
                var dayIsBeforeMinDate = (dateRangeParams.minDate) ? evalDate < dateRangeParams.minDate : false;
                /** @type {?} */
                var dayIsAfterMaxDate = (dateRangeParams.maxDate) ? evalDate > dateRangeParams.maxDate : false;
                return dayIsBeforeMinDate || dayIsAfterMaxDate;
            };
        /**
         * @param {?} year
         * @param {?} month
         * @return {?}
         */
        UTCDateAdapter.prototype.getMonthInfo = /**
         * @param {?} year
         * @param {?} month
         * @return {?}
         */
            function (year, month) {
                return new Date(year, month, 15);
            };
        /**
         * @param {?} date
         * @return {?}
         */
        UTCDateAdapter.prototype.month = /**
         * @param {?} date
         * @return {?}
         */
            function (date) {
                return date.getUTCMonth();
            };
        /**
         * @param {?=} year
         * @param {?=} month
         * @param {?=} day
         * @return {?}
         */
        UTCDateAdapter.prototype.newDateFromArray = /**
         * @param {?=} year
         * @param {?=} month
         * @param {?=} day
         * @return {?}
         */
            function (year, month, day) {
                return new Date(Date.UTC(year, month, day));
            };
        /**
         * @param {?=} value
         * @return {?}
         */
        UTCDateAdapter.prototype.newDateFromValue = /**
         * @param {?=} value
         * @return {?}
         */
            function (value) {
                return (value) ? this.processDateInput(value) : this.getZerodDate(new Date());
            };
        /**
         * @param {?} date
         * @return {?}
         */
        UTCDateAdapter.prototype.prepHeaderDate = /**
         * @param {?} date
         * @return {?}
         */
            function (date) {
                return localize(this.languageCode, this.addTimezoneOffset(date), 'EEE, MMM d');
            };
        /**
         * @param {?} date
         * @return {?}
         */
        UTCDateAdapter.prototype.prepHeaderYear = /**
         * @param {?} date
         * @return {?}
         */
            function (date) {
                return localize(this.languageCode, this.addTimezoneOffset(date), 'yyyy');
            };
        /**
         * @param {?} _calendarDay
         * @param {?} _comparator
         * @return {?}
         */
        UTCDateAdapter.prototype.sameDay = /**
         * @param {?} _calendarDay
         * @param {?} _comparator
         * @return {?}
         */
            function (_calendarDay, _comparator) {
                return _calendarDay.day === _comparator.getUTCDate()
                    && _calendarDay.month === _comparator.getUTCMonth()
                    && _calendarDay.year === _comparator.getUTCFullYear();
            };
        /**
         * @param {?} date
         * @return {?}
         */
        UTCDateAdapter.prototype.year = /**
         * @param {?} date
         * @return {?}
         */
            function (date) {
                return date.getUTCFullYear();
            };
        /**
         * @return {?}
         */
        UTCDateAdapter.prototype.weekdays = /**
         * @return {?}
         */
            function () {
                return getWeekdays(this.languageCode);
            };
        /**
         * @return {?}
         */
        UTCDateAdapter.prototype.months = /**
         * @return {?}
         */
            function () {
                return getMonths(this.languageCode);
            };
        /**
         * @param {?} input
         * @return {?}
         */
        UTCDateAdapter.prototype.prepDateStringOutput = /**
         * @param {?} input
         * @return {?}
         */
            function (input) {
                return (input) ? new Date(this.processDateInput(input)).toLocaleDateString(this._locale, { timeZone: 'UTC' }) : '';
            };
        /**
         * @param {?} input
         * @return {?}
         */
        UTCDateAdapter.prototype.processDateInput = /**
         * @param {?} input
         * @return {?}
         */
            function (input) {
                if (!input) {
                    return null;
                }
                if (typeof input === 'string') {
                    /** @type {?} */
                    var dateSegments = parseInput(input, this._locale);
                    if (Array.isArray(dateSegments.splitDate) && dateSegments.splitDate.length === 3 && dateSegments.year) {
                        return new Date(Date.UTC(parseInt(dateSegments.year, 10), parseInt(dateSegments.month, 10) - 1, parseInt(dateSegments.day, 10)));
                    }
                    else {
                        // This is a fallback for malformed date string, outcome unknown
                        return new Date(input);
                    }
                }
                else {
                    return this.getZerodDate(input);
                }
            };
        /**
         * @private
         * @param {?} date
         * @return {?}
         */
        UTCDateAdapter.prototype.addTimezoneOffset = /**
         * @private
         * @param {?} date
         * @return {?}
         */
            function (date) {
                /** @type {?} */
                var newDate = new Date(date);
                /** @type {?} */
                var timeOffsetInMS = date.getTimezoneOffset() * 60000;
                newDate.setTime(date.getTime() + timeOffsetInMS);
                return newDate;
            };
        /**
         * @private
         * @param {?} date
         * @return {?}
         */
        UTCDateAdapter.prototype.getZerodDate = /**
         * @private
         * @param {?} date
         * @return {?}
         */
            function (date) {
                /** @type {?} */
                var safeDate = (date._isAMomentObject) ? new Date(date) : date;
                /** @type {?} */
                var day = safeDate.getUTCDate();
                /** @type {?} */
                var month = safeDate.getUTCMonth();
                /** @type {?} */
                var year = safeDate.getUTCFullYear();
                return new Date(Date.UTC(year, month, day));
            };
        UTCDateAdapter.decorators = [
            { type: i0.Injectable }
        ];
        /** @nocollapse */
        UTCDateAdapter.ctorParameters = function () {
            return [
                { type: String, decorators: [{ type: i0.Optional }, { type: i0.Inject, args: [i0.LOCALE_ID,] }] }
            ];
        };
        return UTCDateAdapter;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * \@description A wrapper around the HTML 5 Drag API.
     */
    var DraggableDirective = /** @class */ (function () {
        function DraggableDirective(element) {
            var _this = this;
            this.element = element;
            this.dataFn = function () { return _this.getData(); };
            this.controller = new core.DragController(this.element.nativeElement, this.dataFn).connect();
        }
        /**
         * @private
         * @return {?}
         */
        DraggableDirective.prototype.getData = /**
         * @private
         * @return {?}
         */
            function () {
                return this.anjDraggable;
            };
        DraggableDirective.decorators = [
            { type: i0.Directive, args: [{
                        selector: '[anjDraggable]'
                    },] }
        ];
        /** @nocollapse */
        DraggableDirective.ctorParameters = function () {
            return [
                { type: i0.ElementRef }
            ];
        };
        DraggableDirective.propDecorators = {
            anjDraggable: [{ type: i0.Input }]
        };
        return DraggableDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * \@description A wrapper around the HTML 5 Drop API.
     */
    var DroppableDirective = /** @class */ (function () {
        function DroppableDirective(element) {
            this.element = element;
            this.controller = new core.DropController(this.element.nativeElement).connect();
        }
        DroppableDirective.decorators = [
            { type: i0.Directive, args: [{
                        selector: '[anjDroppable]'
                    },] }
        ];
        /** @nocollapse */
        DroppableDirective.ctorParameters = function () {
            return [
                { type: i0.ElementRef }
            ];
        };
        return DroppableDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * \@internal
     */
    var ResizerDirective = /** @class */ (function () {
        function ResizerDirective(anjResizer, element) {
            this.anjResizer = anjResizer;
            this.element = element;
            this.resize = new i0.EventEmitter();
            this.resizeListener = this.handleResize.bind(this);
        }
        /**
         * @return {?}
         */
        ResizerDirective.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                window.addEventListener('resize', this.resizeListener);
                this.parentElement = this.element.nativeElement.parentElement;
                this.getDimensions();
            };
        /**
         * @return {?}
         */
        ResizerDirective.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                window.clearTimeout(this.resizeDebouncer);
                window.removeEventListener('resize', this.resizeListener);
            };
        /**
         * @return {?}
         */
        ResizerDirective.prototype.handleResize = /**
         * @return {?}
         */
            function () {
                var _this = this;
                window.clearTimeout(this.resizeDebouncer);
                this.resizeDebouncer = window.setTimeout(function () {
                    /** @type {?} */
                    var needsResize = _this.getDimensions();
                    if (needsResize) {
                        _this.resize.emit();
                    }
                }, this.anjResizer);
            };
        /**
         * @return {?}
         */
        ResizerDirective.prototype.getDimensions = /**
         * @return {?}
         */
            function () {
                /** @type {?} */
                var parentWidth = this.parentElement.clientWidth;
                /** @type {?} */
                var parentHeight = this.parentElement.clientHeight;
                if (parentWidth === this.parentWidth && parentHeight === this.parentHeight) {
                    return false;
                }
                this.parentWidth = parentWidth;
                this.parentHeight = parentHeight;
                return true;
            };
        ResizerDirective.decorators = [
            { type: i0.Directive, args: [{
                        selector: '[anjResizer]'
                    },] }
        ];
        /** @nocollapse */
        ResizerDirective.ctorParameters = function () {
            return [
                { type: Number, decorators: [{ type: i0.Attribute, args: ['anjResizer',] }] },
                { type: i0.ElementRef }
            ];
        };
        ResizerDirective.propDecorators = {
            resize: [{ type: i0.Output }]
        };
        return ResizerDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DomOutlet = /** @class */ (function () {
        function DomOutlet(targetElement) {
            this.targetElement = targetElement;
        }
        Object.defineProperty(DomOutlet.prototype, "viewRef", {
            get: /**
             * @return {?}
             */ function () {
                return this._viewRef;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @template C
         * @param {?} template
         * @return {?}
         */
        DomOutlet.prototype.attachTemplate = /**
         * @template C
         * @param {?} template
         * @return {?}
         */
            function (template) {
                var _this = this;
                this._viewRef = template.viewContainerRef.createEmbeddedView(template.templateRef, template.context);
                this._viewRef.detectChanges();
                this._viewRef.rootNodes.forEach(function (rootNode) { return _this.targetElement.appendChild(rootNode); });
                this.setDisposeFn((function () {
                    /** @type {?} */
                    var index = template.viewContainerRef.indexOf(_this._viewRef);
                    if (index !== -1) {
                        template.viewContainerRef.remove(index);
                    }
                }));
                return this._viewRef;
            };
        /**
         * @param {?} context
         * @return {?}
         */
        DomOutlet.prototype.updateContext = /**
         * @param {?} context
         * @return {?}
         */
            function (context) {
                for (var prop in context) {
                    if (context.hasOwnProperty(prop)) {
                        this._viewRef.context[prop] = context[prop];
                    }
                }
            };
        /**
         * @param {?} fn
         * @return {?}
         */
        DomOutlet.prototype.setDisposeFn = /**
         * @param {?} fn
         * @return {?}
         */
            function (fn) {
                this.disposeFn = fn;
            };
        /**
         * @param {?} template
         * @return {?}
         */
        DomOutlet.prototype.attach = /**
         * @param {?} template
         * @return {?}
         */
            function (template) {
                this.template = template;
                return this.attachTemplate(template);
            };
        /**
         * @return {?}
         */
        DomOutlet.prototype.detach = /**
         * @return {?}
         */
            function () {
                if (this.template) {
                    this.template.setAttachedHost(null);
                    this.template = null;
                }
                this.invokeDisposeFn();
            };
        /**
         * @return {?}
         */
        DomOutlet.prototype.dispose = /**
         * @return {?}
         */
            function () {
                this.disposeFn();
                if (this.targetElement.parentNode != null) {
                    this.targetElement.parentNode.removeChild(this.targetElement);
                }
                return undefined;
            };
        /**
         * @private
         * @return {?}
         */
        DomOutlet.prototype.invokeDisposeFn = /**
         * @private
         * @return {?}
         */
            function () {
                if (this.disposeFn) {
                    this.disposeFn();
                    this.disposeFn = null;
                }
            };
        return DomOutlet;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var Template = /** @class */ (function () {
        function Template(templateRef, viewContainerRef, context) {
            this.templateRef = templateRef;
            this.viewContainerRef = viewContainerRef;
            this.context = context;
        }
        Object.defineProperty(Template.prototype, "origin", {
            get: /**
             * @return {?}
             */ function () {
                return this.templateRef.elementRef;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} host
         * @param {?=} context
         * @return {?}
         */
        Template.prototype.attach = /**
         * @param {?} host
         * @param {?=} context
         * @return {?}
         */
            function (host, context) {
                if (context === void 0) {
                    context = this.context;
                }
                this.context = context;
                this.host = host;
                return host.attach(this);
            };
        /**
         * @return {?}
         */
        Template.prototype.detach = /**
         * @return {?}
         */
            function () {
                this.context = undefined;
                if (this.host) {
                    /** @type {?} */
                    var host = this.host;
                    this.host = null;
                    host.detach();
                }
            };
        /**
         * @param {?} host
         * @return {?}
         */
        Template.prototype.setAttachedHost = /**
         * @param {?} host
         * @return {?}
         */
            function (host) {
                this.host = host;
            };
        return Template;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var TemplateDirective = /** @class */ (function () {
        function TemplateDirective(_template) {
            this._template = _template;
        }
        Object.defineProperty(TemplateDirective.prototype, "anjTemplateOf", {
            set: /**
             * @param {?} name
             * @return {?}
             */ function (name) {
                this._name = name;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TemplateDirective.prototype, "name", {
            get: /**
             * @return {?}
             */ function () {
                return this._name;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TemplateDirective.prototype, "template", {
            get: /**
             * @return {?}
             */ function () {
                return this._template;
            },
            enumerable: true,
            configurable: true
        });
        TemplateDirective.decorators = [
            { type: i0.Directive, args: [{
                        selector: '[anjTemplate]'
                    },] }
        ];
        /** @nocollapse */
        TemplateDirective.ctorParameters = function () {
            return [
                { type: i0.TemplateRef }
            ];
        };
        TemplateDirective.propDecorators = {
            anjTemplateOf: [{ type: i0.Input }]
        };
        return TemplateDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /* tslint:disable:directive-selector */
    var AnjTable = /** @class */ (function () {
        function AnjTable(changeRef, viewRef, elRef) {
            this.changeRef = changeRef;
            this.viewRef = viewRef;
            this.outletRows = [];
            this.element = elRef.nativeElement;
            this.element.renderer = this;
        }
        /**
         * @private
         * @param {?} row
         * @param {?} index
         * @param {?=} column
         * @return {?}
         */
        AnjTable.rowContext = /**
         * @private
         * @param {?} row
         * @param {?} index
         * @param {?=} column
         * @return {?}
         */
            function (row, index, column) {
                return {
                    $implicit: row,
                    column: column,
                    index: index
                };
            };
        /**
         * @return {?}
         */
        AnjTable.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                this.outletRows.map(function (rowMap) {
                    for (var templateName in rowMap) {
                        if (rowMap[templateName]) {
                            rowMap[templateName] = rowMap[templateName].dispose();
                        }
                    }
                    return rowMap;
                });
            };
        /**
         * @param {?} cell
         * @param {?} offset
         * @param {?} col
         * @param {?} row
         * @param {?} rowIndex
         * @return {?}
         */
        AnjTable.prototype.cellTemplate = /**
         * @param {?} cell
         * @param {?} offset
         * @param {?} col
         * @param {?} row
         * @param {?} rowIndex
         * @return {?}
         */
            function (cell, offset, col, row, rowIndex) {
                this.fromTemplate(col.cellTemplate, cell, row, rowIndex);
                col.initCell(cell, offset);
            };
        /**
         * @param {?} templateName
         * @param {?} targetEl
         * @param {?} row
         * @param {?} rowIndex
         * @return {?}
         */
        AnjTable.prototype.fromTemplate = /**
         * @param {?} templateName
         * @param {?} targetEl
         * @param {?} row
         * @param {?} rowIndex
         * @return {?}
         */
            function (templateName, targetEl, row, rowIndex) {
                /** @type {?} */
                var rowMap = this.outletRows[rowIndex] || {};
                /** @type {?} */
                var outlet = rowMap[templateName];
                if (!targetEl) {
                    rowMap[templateName] = outlet.dispose();
                    return;
                }
                if (outlet) {
                    if (targetEl !== outlet.targetElement) {
                        this.updateOutlet(outlet, templateName, targetEl, AnjTable.rowContext(row, rowIndex));
                    }
                    else {
                        this.updateContext(outlet, AnjTable.rowContext(row, rowIndex));
                    }
                }
                else {
                    rowMap[templateName] = this.createOutlet(targetEl, templateName, AnjTable.rowContext(row, rowIndex));
                    this.outletRows[rowIndex] = rowMap;
                }
            };
        /**
         * @private
         * @param {?} target
         * @param {?} templateName
         * @param {?} context
         * @return {?}
         */
        AnjTable.prototype.createOutlet = /**
         * @private
         * @param {?} target
         * @param {?} templateName
         * @param {?} context
         * @return {?}
         */
            function (target, templateName, context) {
                /** @type {?} */
                var outlet = new DomOutlet(target);
                outlet.attach(this.createTemplate(templateName, context));
                return outlet;
            };
        /**
         * @private
         * @param {?} templateName
         * @param {?} context
         * @return {?}
         */
        AnjTable.prototype.createTemplate = /**
         * @private
         * @param {?} templateName
         * @param {?} context
         * @return {?}
         */
            function (templateName, context) {
                /** @type {?} */
                var templateRef = this.templates.find(function (t) { return t.name === templateName; }).template;
                return new Template(templateRef, this.viewRef, context);
            };
        /**
         * @private
         * @param {?} outlet
         * @param {?} context
         * @return {?}
         */
        AnjTable.prototype.updateContext = /**
         * @private
         * @param {?} outlet
         * @param {?} context
         * @return {?}
         */
            function (outlet, context) {
                outlet.updateContext(context);
                this.changeRef.markForCheck();
            };
        /**
         * @private
         * @param {?} outlet
         * @param {?} templateName
         * @param {?} targetEl
         * @param {?} context
         * @return {?}
         */
        AnjTable.prototype.updateOutlet = /**
         * @private
         * @param {?} outlet
         * @param {?} templateName
         * @param {?} targetEl
         * @param {?} context
         * @return {?}
         */
            function (outlet, templateName, targetEl, context) {
                outlet.targetElement = targetEl;
                outlet.detach();
                outlet.attach(this.createTemplate(templateName, context));
            };
        AnjTable.decorators = [
            { type: i0.Directive, args: [{
                        selector: 'anj-table:not([anjIgnore])',
                    },] }
        ];
        /** @nocollapse */
        AnjTable.ctorParameters = function () {
            return [
                { type: i0.ChangeDetectorRef },
                { type: i0.ViewContainerRef },
                { type: i0.ElementRef }
            ];
        };
        AnjTable.propDecorators = {
            templates: [{ type: i0.ContentChildren, args: [TemplateDirective,] }]
        };
        return AnjTable;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @enum {number} */
    var TransitionState = {
        Enter: 0,
        Leave: 1,
        EnterTo: 2,
        Inactive: 3,
    };
    TransitionState[TransitionState.Enter] = 'Enter';
    TransitionState[TransitionState.Leave] = 'Leave';
    TransitionState[TransitionState.EnterTo] = 'EnterTo';
    TransitionState[TransitionState.Inactive] = 'Inactive';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * \@experimental
     */
    var TransitionDirective = /** @class */ (function () {
        function TransitionDirective(renderer, element, mode, name) {
            this.renderer = renderer;
            this.element = element;
            this.mode = mode;
            this.name = name;
            this.state = TransitionState.EnterTo;
            this.end = new i0.EventEmitter();
            this.mode = this.mode ? this.mode : 'in-out';
            this.name = this.name ? this.name : 'transition';
        }
        /**
         * @param {?} changes
         * @return {?}
         */
        TransitionDirective.prototype.ngOnChanges = /**
         * @param {?} changes
         * @return {?}
         */
            function (changes) {
                this.endTransition();
                if (!changes.anjTransition.previousValue && !changes.anjTransition.currentValue && this.mode !== 'out') {
                    this.initEnter();
                }
                else if (!changes.anjTransition.previousValue && changes.anjTransition.currentValue) {
                    this.transitionIn();
                }
                else {
                    this.transitionOut();
                }
            };
        /**
         * @param {?} event
         * @return {?}
         */
        TransitionDirective.prototype.handleTransition = /**
         * @param {?} event
         * @return {?}
         */
            function (event) {
                if (event.target === this.element.nativeElement && TransitionDirective.supportedTransitions.indexOf(event.propertyName) > -1) {
                    event.stopPropagation();
                    this.end.emit(this.state);
                    if (this.state === TransitionState.Enter) {
                        this.endTransition();
                    }
                    else {
                        if (this.mode !== 'out' && this.anjTransition) {
                            this.transitionIn();
                        }
                        else {
                            this.endTransition();
                        }
                    }
                }
            };
        /**
         * @private
         * @return {?}
         */
        TransitionDirective.prototype.initEnter = /**
         * @private
         * @return {?}
         */
            function () {
                this.renderer.addClass(this.element.nativeElement, "anj-" + this.name + "-enter-to");
            };
        /**
         * @private
         * @return {?}
         */
        TransitionDirective.prototype.transitionIn = /**
         * @private
         * @return {?}
         */
            function () {
                if (this.mode !== 'out') {
                    this.state = TransitionState.Enter;
                    this.renderer.removeClass(this.element.nativeElement, "anj-" + this.name + "-enter-to");
                    this.renderer.removeClass(this.element.nativeElement, "anj-" + this.name + "-leave");
                    this.renderer.removeClass(this.element.nativeElement, "anj-" + this.name + "-leave-active");
                    this.renderer.addClass(this.element.nativeElement, "anj-" + this.name + "-enter-active");
                    this.renderer.addClass(this.element.nativeElement, "anj-" + this.name + "-enter");
                }
                else {
                    this.renderer.removeClass(this.element.nativeElement, "anj-" + this.name + "-enter-to");
                    this.endTransition();
                }
            };
        /**
         * @private
         * @return {?}
         */
        TransitionDirective.prototype.transitionOut = /**
         * @private
         * @return {?}
         */
            function () {
                var _this = this;
                this.state = TransitionState.Leave;
                if (this.mode !== 'in') {
                    this.renderer.addClass(this.element.nativeElement, "anj-" + this.name + "-leave-active");
                    this.renderer.addClass(this.element.nativeElement, "anj-" + this.name + "-leave");
                }
                else {
                    this.renderer.addClass(this.element.nativeElement, "anj-" + this.name + "-enter-to");
                    this.state = TransitionState.EnterTo;
                    if (this.anjTransition) {
                        window.setTimeout(function () {
                            _this.transitionIn();
                        });
                    }
                }
            };
        /**
         * @private
         * @return {?}
         */
        TransitionDirective.prototype.endTransition = /**
         * @private
         * @return {?}
         */
            function () {
                this.state = TransitionState.Inactive;
                this.renderer.removeClass(this.element.nativeElement, "anj-" + this.name + "-enter-active");
                this.renderer.removeClass(this.element.nativeElement, "anj-" + this.name + "-leave-active");
                this.renderer.removeClass(this.element.nativeElement, "anj-" + this.name + "-enter");
                this.renderer.removeClass(this.element.nativeElement, "anj-" + this.name + "-leave");
                if (!this.anjTransition) {
                    this.renderer.addClass(this.element.nativeElement, "anj-" + this.name + "-enter-to");
                }
            };
        TransitionDirective.supportedTransitions = ['opacity', 'transform'];
        TransitionDirective.decorators = [
            { type: i0.Directive, args: [{
                        selector: '[anjTransition]'
                    },] }
        ];
        /** @nocollapse */
        TransitionDirective.ctorParameters = function () {
            return [
                { type: i0.Renderer2 },
                { type: i0.ElementRef },
                { type: undefined, decorators: [{ type: i0.Attribute, args: ['mode',] }] },
                { type: String, decorators: [{ type: i0.Attribute, args: ['name',] }] }
            ];
        };
        TransitionDirective.propDecorators = {
            anjTransition: [{ type: i0.Input }],
            end: [{ type: i0.Output }],
            handleTransition: [{ type: i0.HostListener, args: ['transitiend', ['$event'],] }]
        };
        return TransitionDirective;
    }());

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (b.hasOwnProperty(p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ValueAccessor = /** @class */ (function () {
        function ValueAccessor(element, parentForm, parentGroup) {
            this.element = element;
            /**
             * Enable two-way binding
             */
            this.valueChange = new i0.EventEmitter();
            this.onChange = function () { };
            this.onTouched = function () { };
            this.parent = parentForm ? parentForm : parentGroup ? parentGroup : null;
            if (this.parent) {
                this.formSub = this.parent.ngSubmit.subscribe(this.checkValidity.bind(this));
            }
        }
        /**
         * @return {?}
         */
        ValueAccessor.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                if (this.formSub) {
                    this.formSub.unsubscribe();
                }
            };
        /**
         * @param {?} value
         * @return {?}
         */
        ValueAccessor.prototype.writeValue = /**
         * @param {?} value
         * @return {?}
         */
            function (value) {
                this.element.nativeElement.value = this.lastValue = value == null ? '' : value;
            };
        /**
         * @param {?} value
         * @return {?}
         */
        ValueAccessor.prototype.onChangeEvent = /**
         * @param {?} value
         * @return {?}
         */
            function (value) {
                if (value !== this.lastValue) {
                    this.lastValue = value;
                    this.onChange(value);
                    this.valueChange.emit(value);
                }
            };
        /**
         * @return {?}
         */
        ValueAccessor.prototype.onAnjBlur = /**
         * @return {?}
         */
            function () {
                this.onTouched();
                this.checkValidity();
            };
        /**
         * @param {?} fn
         * @return {?}
         */
        ValueAccessor.prototype.registerOnChange = /**
         * @param {?} fn
         * @return {?}
         */
            function (fn) {
                this.onChange = fn;
            };
        /**
         * @param {?} fn
         * @return {?}
         */
        ValueAccessor.prototype.registerOnTouched = /**
         * @param {?} fn
         * @return {?}
         */
            function (fn) {
                this.onTouched = fn;
            };
        /**
         * @param {?} isDisabled
         * @return {?}
         */
        ValueAccessor.prototype.setDisabledState = /**
         * @param {?} isDisabled
         * @return {?}
         */
            function (isDisabled) {
                this.element.nativeElement.disabled = isDisabled;
            };
        /**
         * @return {?}
         */
        ValueAccessor.prototype.checkValidity = /**
         * @return {?}
         */
            function () {
                // TODO: this won't work for custom validators
                this.element.nativeElement.checkValidity();
            };
        ValueAccessor.propDecorators = {
            valueChange: [{ type: i0.Output }],
            onAnjBlur: [{ type: i0.HostListener, args: ['anjBlur',] }]
        };
        return ValueAccessor;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /* tslint:disable:directive-selector */
    var BooleanValueDirective = /** @class */ (function (_super) {
        __extends(BooleanValueDirective, _super);
        function BooleanValueDirective(parentForm, parentFormGroup, element) {
            return _super.call(this, element, parentForm, parentFormGroup) || this;
        }
        /**
         * @param {?} value
         * @return {?}
         */
        BooleanValueDirective.prototype.onAnjChange = /**
         * @param {?} value
         * @return {?}
         */
            function (value) {
                this.onChangeEvent(value);
                this.checkValidity();
            };
        BooleanValueDirective.decorators = [
            { type: i0.Directive, args: [{
                        selector: 'anj-checkbox, anj-toggle',
                        providers: [
                            {
                                provide: forms.NG_VALUE_ACCESSOR,
                                useExisting: BooleanValueDirective,
                                multi: true
                            }
                        ]
                    },] }
        ];
        /** @nocollapse */
        BooleanValueDirective.ctorParameters = function () {
            return [
                { type: forms.NgForm, decorators: [{ type: i0.Optional }] },
                { type: forms.FormGroupDirective, decorators: [{ type: i0.Optional }] },
                { type: i0.ElementRef }
            ];
        };
        BooleanValueDirective.propDecorators = {
            onAnjChange: [{ type: i0.HostListener, args: ['anjChange', ['$event.target.checked'],] }]
        };
        return BooleanValueDirective;
    }(ValueAccessor));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * \@dynamic
     * @abstract
     */
    var AnjunaValidators = /** @class */ (function () {
        function AnjunaValidators() {
        }
        /**
         * @param {?} c
         * @return {?}
         */
        AnjunaValidators.date = /**
         * @param {?} c
         * @return {?}
         */
            function (c) {
                if (!c.value) {
                    return;
                }
                /** @type {?} */
                var isValid = true;
                console.log(c.value);
                // Handle obvious Invalid Date
                if (c.value.toString() === 'Invalid Date') {
                    isValid = false;
                    // Handle Moment Date
                }
                else if (typeof c.value._isValid === 'boolean') {
                    isValid = c.value._isValid;
                    // Handle Native Date
                }
                else {
                    isValid = !isNaN(new Date(c.value).getTime());
                }
                if (isValid || c.value === '') {
                    return null;
                }
                else {
                    return {
                        date: {
                            valid: false
                        }
                    };
                }
            };
        /**
         * @param {?} c
         * @return {?}
         */
        AnjunaValidators.requiredCheck = /**
         * @param {?} c
         * @return {?}
         */
            function (c) {
                if (c.value) {
                    return null;
                }
                else {
                    return {
                        required: {
                            valid: false
                        }
                    };
                }
            };
        /**
         * @param {?} c
         * @return {?}
         */
        AnjunaValidators.unique = /**
         * @param {?} c
         * @return {?}
         */
            function (c) {
                if (!c.value || !Array.isArray(c.value)) {
                    return;
                }
                /** @type {?} */
                var testArray = c.value.filter(Boolean);
                /** @type {?} */
                var isValid = testArray.length === Array.from(new Set(testArray)).length;
                if (isValid) {
                    return null;
                }
                else {
                    return {
                        unique: {
                            valid: false
                        }
                    };
                }
            };
        AnjunaValidators.minDate = function (min) {
            return function (c) {
                if (!c.value) {
                    return;
                }
                if (c.value < new Date(min)) {
                    return {
                        min: {
                            valid: false
                        }
                    };
                }
                else {
                    return null;
                }
            };
        };
        AnjunaValidators.maxDate = function (max) {
            return function (c) {
                if (!c.value) {
                    return;
                }
                if (c.value > new Date(max)) {
                    return {
                        max: {
                            valid: false
                        }
                    };
                }
                else {
                    return null;
                }
            };
        };
        return AnjunaValidators;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /* tslint:disable:directive-selector */
    var DateValidatorDirective = /** @class */ (function () {
        function DateValidatorDirective() {
        }
        /**
         * @param {?} c
         * @return {?}
         */
        DateValidatorDirective.prototype.validate = /**
         * @param {?} c
         * @return {?}
         */
            function (c) {
                return AnjunaValidators.date(c);
            };
        DateValidatorDirective.decorators = [
            { type: i0.Directive, args: [{
                        selector: '[date][ngModel],[date][formControl]',
                        providers: [
                            { provide: forms.NG_VALIDATORS, useExisting: DateValidatorDirective, multi: true }
                        ]
                    },] }
        ];
        return DateValidatorDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DatePickerDirective = /** @class */ (function () {
        function DatePickerDirective(renderer, _element, changeRef, dateAdapter, parentForm, parentFormGroup, ngControl, _locale) {
            this.renderer = renderer;
            this._element = _element;
            this.changeRef = changeRef;
            this.dateAdapter = dateAdapter;
            this.ngControl = ngControl;
            this.onChange = function () {
            };
            this.onTouch = function () {
            };
            this.languageCode = (_locale) ? _locale.split('-')[0] : 'en';
            this.valueChange = new i0.EventEmitter();
            this.adapterStrategy = dateAdapter;
            if (this.ngControl) {
                this.ngControl.valueAccessor = this;
            }
            this.parent = parentForm ? parentForm : parentFormGroup ? parentFormGroup : null;
        }
        Object.defineProperty(DatePickerDirective.prototype, "value", {
            // Custom input to return inner value, but display masked value
            get: 
            // Custom input to return inner value, but display masked value
            /**
             * @return {?}
             */
            function () { return this.innerDateValue; },
            set: /**
             * @param {?} dateValue
             * @return {?}
             */ function (dateValue) {
                if (dateValue) {
                    this.innerDateValue = this.adapterStrategy.processDateInput(dateValue);
                    this.outerValue = this.adapterStrategy.prepDateStringOutput(dateValue);
                    this.changeRef.markForCheck();
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DatePickerDirective.prototype, "adapter", {
            // AdapterStrategy will be set by the DateAdapter injected provider. This is for an optional override.
            set: 
            // AdapterStrategy will be set by the DateAdapter injected provider. This is for an optional override.
            /**
             * @param {?} adapter
             * @return {?}
             */
            function (adapter) {
                this.adapterStrategy = adapter;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        DatePickerDirective.prototype.ngAfterViewInit = /**
         * @return {?}
         */
            function () {
                if (this.ngControl) {
                    this.value = this.ngControl.value;
                    this.changeRef.detectChanges();
                }
            };
        /**
         * @return {?}
         */
        DatePickerDirective.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                if (this.listenerFn) {
                    this.listenerFn();
                }
            };
        // // Start: ControlValueAccessor requirements
        // // Start: ControlValueAccessor requirements
        /**
         * @param {?} newValue
         * @return {?}
         */
        DatePickerDirective.prototype.writeValue =
            // // Start: ControlValueAccessor requirements
            /**
             * @param {?} newValue
             * @return {?}
             */
            function (newValue) {
                this.value = newValue;
            };
        /**
         * @param {?} fn
         * @return {?}
         */
        DatePickerDirective.prototype.registerOnChange = /**
         * @param {?} fn
         * @return {?}
         */
            function (fn) {
                this.onChange = fn;
            };
        /**
         * @param {?} fn
         * @return {?}
         */
        DatePickerDirective.prototype.registerOnTouched = /**
         * @param {?} fn
         * @return {?}
         */
            function (fn) {
                this.onTouch = fn;
            };
        // // End: ControlValueAccessor requirements
        // // End: ControlValueAccessor requirements
        /**
         * @param {?} event
         * @return {?}
         */
        DatePickerDirective.prototype.onInput =
            // // End: ControlValueAccessor requirements
            /**
             * @param {?} event
             * @return {?}
             */
            function (event) {
                if (event.target.tagName === 'ANJ-INPUT') {
                    this.onTouch();
                    this.updateInnerValue(event.target.value);
                    this.valueChange.emit(this.innerDateValue);
                    this.isInvalid();
                }
            };
        /**
         * @param {?} event
         * @return {?}
         */
        DatePickerDirective.prototype.onCalendarSelect = /**
         * @param {?} event
         * @return {?}
         */
            function (event) {
                this.onTouch();
                this.updateInnerValue(event.detail);
                this.valueChange.emit(this.innerDateValue);
                this.isInvalid();
            };
        /**
         * @private
         * @return {?}
         */
        DatePickerDirective.prototype.isInvalid = /**
         * @private
         * @return {?}
         */
            function () {
                if (!this.ngControl) {
                    return;
                }
                /** @type {?} */
                var isSubmitted = (this.parent && this.parent.submitted);
                this.ngInvalid = this.ngControl.invalid && (this.ngControl.touched || isSubmitted);
                this._element.nativeElement
                    .dispatchEvent(new CustomEvent('anjInvalid', {
                    detail: this.ngInvalid,
                    bubbles: true
                }));
                this.changeRef.markForCheck();
            };
        // convert the masked value to storage value
        // convert the masked value to storage value
        /**
         * @private
         * @param {?} inputDate
         * @return {?}
         */
        DatePickerDirective.prototype.updateInnerValue =
            // convert the masked value to storage value
            /**
             * @private
             * @param {?} inputDate
             * @return {?}
             */
            function (inputDate) {
                this.innerDateValue = this.adapterStrategy.processDateInput(inputDate);
                this.propogateInnerValueChange();
            };
        /**
         * @private
         * @return {?}
         */
        DatePickerDirective.prototype.propogateInnerValueChange = /**
         * @private
         * @return {?}
         */
            function () {
                if (this.ngControl) {
                    this.ngControl.control.setValue(this.innerDateValue);
                }
                this.valueChange.emit(this.innerDateValue);
            };
        DatePickerDirective.decorators = [
            { type: i0.Directive, args: [{
                        selector: 'anj-input[anjDatePicker]',
                        exportAs: 'anjDatepickerInput'
                    },] }
        ];
        /** @nocollapse */
        DatePickerDirective.ctorParameters = function () {
            return [
                { type: i0.Renderer2 },
                { type: i0.ElementRef },
                { type: i0.ChangeDetectorRef },
                { type: DateAdapter },
                { type: forms.NgForm, decorators: [{ type: i0.Optional }] },
                { type: forms.FormGroupDirective, decorators: [{ type: i0.Optional }] },
                { type: forms.NgControl, decorators: [{ type: i0.Optional }, { type: i0.Self }] },
                { type: String, decorators: [{ type: i0.Optional }, { type: i0.Inject, args: [i0.LOCALE_ID,] }] }
            ];
        };
        DatePickerDirective.propDecorators = {
            value: [{ type: i0.Input }],
            adapter: [{ type: i0.Input }],
            outerValue: [{ type: i0.HostBinding, args: ['value',] }],
            invalid: [{ type: i0.HostBinding, args: ['attr.invalid',] }],
            languageCode: [{ type: i0.HostBinding, args: ['attr.language',] }],
            onInput: [{ type: i0.HostListener, args: ['anjBlur', ['$event'],] }],
            onCalendarSelect: [{ type: i0.HostListener, args: ['anjCalendarSelection', ['$event'],] }]
        };
        return DatePickerDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /* tslint:disable:directive-selector */
    var TextValueDirective = /** @class */ (function (_super) {
        __extends(TextValueDirective, _super);
        function TextValueDirective(parentForm, parentFormGroup, element) {
            return _super.call(this, element, parentForm, parentFormGroup) || this;
        }
        /**
         * @param {?} value
         * @return {?}
         */
        TextValueDirective.prototype.onAnjChange = /**
         * @param {?} value
         * @return {?}
         */
            function (value) {
                this.onChangeEvent(value);
                if (this.element.nativeElement.invalid) {
                    this.checkValidity();
                }
            };
        TextValueDirective.decorators = [
            { type: i0.Directive, args: [{
                        selector: 'anj-input, anj-textarea',
                        providers: [
                            {
                                provide: forms.NG_VALUE_ACCESSOR,
                                useExisting: TextValueDirective,
                                multi: true
                            }
                        ]
                    },] }
        ];
        /** @nocollapse */
        TextValueDirective.ctorParameters = function () {
            return [
                { type: forms.NgForm, decorators: [{ type: i0.Optional }] },
                { type: forms.FormGroupDirective, decorators: [{ type: i0.Optional }] },
                { type: i0.ElementRef }
            ];
        };
        TextValueDirective.propDecorators = {
            onAnjChange: [{ type: i0.HostListener, args: ['anjChange', ['$event.detail.value'],] }]
        };
        return TextValueDirective;
    }(ValueAccessor));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /* tslint:disable:directive-selector */
    var RequiredCheckDirective = /** @class */ (function () {
        function RequiredCheckDirective() {
        }
        /**
         * @param {?} c
         * @return {?}
         */
        RequiredCheckDirective.prototype.validate = /**
         * @param {?} c
         * @return {?}
         */
            function (c) {
                return AnjunaValidators.requiredCheck(c);
            };
        RequiredCheckDirective.decorators = [
            { type: i0.Directive, args: [{
                        selector: 'anj-checkbox[required][ngModel], anj-toggle[required][ngModel]',
                        providers: [
                            { provide: forms.NG_VALIDATORS, useExisting: RequiredCheckDirective, multi: true }
                        ]
                    },] }
        ];
        return RequiredCheckDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /* tslint:disable:directive-selector */
    var SelectValueDirective = /** @class */ (function (_super) {
        __extends(SelectValueDirective, _super);
        function SelectValueDirective(parentForm, parentFormGroup, element) {
            return _super.call(this, element, parentForm, parentFormGroup) || this;
        }
        /**
         * @param {?} target
         * @return {?}
         */
        SelectValueDirective.prototype.onAnjChange = /**
         * @param {?} target
         * @return {?}
         */
            function (target) {
                // ignore the input for type-aheads
                if (target.matches('anj-input')) {
                    return;
                }
                this.onChangeEvent(target.value);
                this.checkValidity();
            };
        SelectValueDirective.decorators = [
            { type: i0.Directive, args: [{
                        selector: 'anj-radio-group, anj-select, anj-type-ahead',
                        providers: [
                            {
                                provide: forms.NG_VALUE_ACCESSOR,
                                useExisting: SelectValueDirective,
                                multi: true
                            }
                        ]
                    },] }
        ];
        /** @nocollapse */
        SelectValueDirective.ctorParameters = function () {
            return [
                { type: forms.NgForm, decorators: [{ type: i0.Optional }] },
                { type: forms.FormGroupDirective, decorators: [{ type: i0.Optional }] },
                { type: i0.ElementRef }
            ];
        };
        SelectValueDirective.propDecorators = {
            onAnjChange: [{ type: i0.HostListener, args: ['anjChange', ['$event.target'],] }]
        };
        return SelectValueDirective;
    }(ValueAccessor));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var TimePickerDirective = /** @class */ (function () {
        function TimePickerDirective(_element, ngControl, _locale, _timezone, _meridiem) {
            this._element = _element;
            this.ngControl = ngControl;
            this._locale = _locale;
            this._timezone = _timezone;
            this._meridiem = _meridiem;
            this.onChange = function () {
            };
            this.onTouch = function () {
            };
            this.valueChange = new i0.EventEmitter();
            if (this.ngControl) {
                this.ngControl.valueAccessor = this;
            }
        }
        /**
         * @return {?}
         */
        TimePickerDirective.prototype.ngAfterViewInit = /**
         * @return {?}
         */
            function () {
                /** @type {?} */
                var picker = this._element.nativeElement.children[0];
                picker.setAttribute('locale', this._locale);
                picker.setAttribute('meridiem', this._meridiem);
                picker.setAttribute('timezone', this._timezone);
            };
        // // Start: ControlValueAccessor requirements
        // // Start: ControlValueAccessor requirements
        /**
         * @param {?} newValue
         * @return {?}
         */
        TimePickerDirective.prototype.writeValue =
            // // Start: ControlValueAccessor requirements
            /**
             * @param {?} newValue
             * @return {?}
             */
            function (newValue) {
                this.value = newValue;
            };
        /**
         * @param {?} fn
         * @return {?}
         */
        TimePickerDirective.prototype.registerOnChange = /**
         * @param {?} fn
         * @return {?}
         */
            function (fn) {
                this.onChange = fn;
            };
        /**
         * @param {?} fn
         * @return {?}
         */
        TimePickerDirective.prototype.registerOnTouched = /**
         * @param {?} fn
         * @return {?}
         */
            function (fn) {
                this.onTouch = fn;
            };
        // // End: ControlValueAccessor requirements
        // // End: ControlValueAccessor requirements
        /**
         * @param {?} event
         * @return {?}
         */
        TimePickerDirective.prototype.onInput =
            // // End: ControlValueAccessor requirements
            /**
             * @param {?} event
             * @return {?}
             */
            function (event) {
                this.value = event.detail;
                if (this.ngControl) {
                    this.ngControl.control.setValue(this.value);
                }
                this.valueChange.emit(this.value);
            };
        TimePickerDirective.decorators = [
            { type: i0.Directive, args: [{
                        selector: 'anj-input[anjTimePicker]',
                        exportAs: 'anjTimepickerInput'
                    },] }
        ];
        /** @nocollapse */
        TimePickerDirective.ctorParameters = function () {
            return [
                { type: i0.ElementRef },
                { type: forms.NgControl, decorators: [{ type: i0.Optional }, { type: i0.Self }] },
                { type: String, decorators: [{ type: i0.Optional }, { type: i0.Inject, args: [i0.LOCALE_ID,] }] },
                { type: String, decorators: [{ type: i0.Optional }, { type: i0.Inject, args: [TENANT_TIMEZONE_STRING,] }] },
                { type: String, decorators: [{ type: i0.Optional }, { type: i0.Inject, args: [TENANT_MERIDIEM,] }] }
            ];
        };
        TimePickerDirective.propDecorators = {
            value: [{ type: i0.HostBinding, args: ['value',] }],
            onInput: [{ type: i0.HostListener, args: ['anjTimeChanged', ['$event'],] }]
        };
        return TimePickerDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ZuoraDatePipe = /** @class */ (function () {
        function ZuoraDatePipe(datePipe) {
            this.datePipe = datePipe;
        }
        /**
         * @param {?} value
         * @param {?=} args
         * @return {?}
         */
        ZuoraDatePipe.prototype.transform = /**
         * @param {?} value
         * @param {?=} args
         * @return {?}
         */
            function (value, args) {
                try {
                    return this.datePipe.transform(value, 'shortDate');
                }
                catch (e) {
                    return;
                }
            };
        ZuoraDatePipe.decorators = [
            { type: i0.Pipe, args: [{
                        name: 'zuoraDate'
                    },] }
        ];
        /** @nocollapse */
        ZuoraDatePipe.ctorParameters = function () {
            return [
                { type: common.DatePipe }
            ];
        };
        return ZuoraDatePipe;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ToastService = /** @class */ (function () {
        function ToastService() {
            this.controller = document.querySelector('anj-toast-controller') || ToastService.createController();
        }
        /**
         * @return {?}
         */
        ToastService.createController = /**
         * @return {?}
         */
            function () {
                /** @type {?} */
                var controller = document.createElement('anj-toast-controller');
                document.body.appendChild(controller);
                return ( /** @type {?} */(controller));
            };
        /**
         * @return {?}
         */
        ToastService.prototype.dismissAll = /**
         * @return {?}
         */
            function () {
                this.controller.dismissAll();
            };
        /**
         * @param {?} message
         * @param {?=} header
         * @return {?}
         */
        ToastService.prototype.error = /**
         * @param {?} message
         * @param {?=} header
         * @return {?}
         */
            function (message, header) {
                return this.controller.error(message, header);
            };
        /**
         * @param {?} message
         * @param {?=} header
         * @return {?}
         */
        ToastService.prototype.message = /**
         * @param {?} message
         * @param {?=} header
         * @return {?}
         */
            function (message, header) {
                return this.controller.message(message, header);
            };
        /**
         * @param {?} message
         * @param {?=} header
         * @return {?}
         */
        ToastService.prototype.success = /**
         * @param {?} message
         * @param {?=} header
         * @return {?}
         */
            function (message, header) {
                return this.controller.success(message, header);
            };
        /**
         * @param {?} message
         * @param {?=} header
         * @return {?}
         */
        ToastService.prototype.warn = /**
         * @param {?} message
         * @param {?=} header
         * @return {?}
         */
            function (message, header) {
                return this.controller.warn(message, header);
            };
        ToastService.decorators = [
            { type: i0.Injectable, args: [{ providedIn: 'root' },] }
        ];
        /** @nocollapse */
        ToastService.ctorParameters = function () { return []; };
        /** @nocollapse */ ToastService.ngInjectableDef = i0.defineInjectable({ factory: function ToastService_Factory() { return new ToastService(); }, token: ToastService, providedIn: "root" });
        return ToastService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var LocalStorageService = /** @class */ (function (_super) {
        __extends(LocalStorageService, _super);
        function LocalStorageService() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        LocalStorageService.decorators = [
            { type: i0.Injectable, args: [{ providedIn: 'root' },] }
        ];
        /** @nocollapse */ LocalStorageService.ngInjectableDef = i0.defineInjectable({ factory: function LocalStorageService_Factory() { return new LocalStorageService(); }, token: LocalStorageService, providedIn: "root" });
        return LocalStorageService;
    }(core.LocalStorage));
    var SessionStorageService = /** @class */ (function (_super) {
        __extends(SessionStorageService, _super);
        function SessionStorageService() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        SessionStorageService.decorators = [
            { type: i0.Injectable, args: [{ providedIn: 'root' },] }
        ];
        /** @nocollapse */ SessionStorageService.ngInjectableDef = i0.defineInjectable({ factory: function SessionStorageService_Factory() { return new SessionStorageService(); }, token: SessionStorageService, providedIn: "root" });
        return SessionStorageService;
    }(core.SessionStorage));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var DECLARATIONS = [
        // Common
        DraggableDirective,
        DroppableDirective,
        ResizerDirective,
        TemplateDirective,
        TransitionDirective,
        ZuoraDatePipe,
        // Forms
        BooleanValueDirective,
        DatePickerDirective,
        DateValidatorDirective,
        RequiredCheckDirective,
        SelectValueDirective,
        TextValueDirective,
        TimePickerDirective,
        // Tables
        AnjTable
    ];
    var AnjunaCoreModule = /** @class */ (function () {
        function AnjunaCoreModule() {
        }
        AnjunaCoreModule.decorators = [
            { type: i0.NgModule, args: [{
                        declarations: DECLARATIONS,
                        exports: DECLARATIONS,
                        providers: [
                            common.DatePipe,
                            {
                                provide: DateAdapter,
                                useClass: NativeDateAdapter,
                                deps: [i0.LOCALE_ID]
                            },
                            ZuoraDatePipe
                        ]
                    },] }
        ];
        return AnjunaCoreModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.getMomentDateAdapter = getMomentDateAdapter;
    exports.MomentDateAdapter = MomentDateAdapter;
    exports.UTCDateAdapter = UTCDateAdapter;
    exports.DraggableDirective = DraggableDirective;
    exports.DroppableDirective = DroppableDirective;
    exports.ResizerDirective = ResizerDirective;
    exports.AnjTable = AnjTable;
    exports.TemplateDirective = TemplateDirective;
    exports.TransitionDirective = TransitionDirective;
    exports.BooleanValueDirective = BooleanValueDirective;
    exports.DateValidatorDirective = DateValidatorDirective;
    exports.DatePickerDirective = DatePickerDirective;
    exports.TextValueDirective = TextValueDirective;
    exports.RequiredCheckDirective = RequiredCheckDirective;
    exports.SelectValueDirective = SelectValueDirective;
    exports.TimePickerDirective = TimePickerDirective;
    exports.TENANT_TIMEZONE_STRING = TENANT_TIMEZONE_STRING;
    exports.TENANT_MERIDIEM = TENANT_MERIDIEM;
    exports.TIMEZONE_OVERRIDE = TIMEZONE_OVERRIDE;
    exports.MOMENT = MOMENT;
    exports.AnjunaValidators = AnjunaValidators;
    exports.ZuoraDatePipe = ZuoraDatePipe;
    exports.ToastService = ToastService;
    exports.LocalStorageService = LocalStorageService;
    exports.SessionStorageService = SessionStorageService;
    exports.getWeekdays = getWeekdays;
    exports.getMonths = getMonths;
    exports.localize = localize;
    exports.parseInput = parseInput;
    exports.STANDARD_LOCALES = STANDARD_LOCALES;
    exports.DateAdapter = DateAdapter;
    exports.NativeDateAdapter = NativeDateAdapter;
    exports.TransitionState = TransitionState;
    exports.AnjunaCoreModule = AnjunaCoreModule;
    exports.ɵa = ValueAccessor;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=anjuna-angular-core.umd.js.map