import { DayWithMetadata } from '../interfaces/DayWithMetadata';
import { DateRangeValidationParams } from '../interfaces/DateRangeValidationParams';
import { DateAdapter } from '../services/date-picker.service';
export declare class MomentDateAdapter implements DateAdapter<any> {
    private _moment;
    private _locale?;
    private _timezone?;
    private moment;
    private timezone;
    private formatterLanguage;
    constructor(_moment: any, _locale?: string, _timezone?: string);
    dayOfFirst(year: number, month: number): number;
    daysInMonth(year: number, month: number): number;
    isDisabled(evalDate: Date, dateRangeParams: DateRangeValidationParams): boolean;
    getMonthInfo(year: number, month: number): Date;
    month(date: Date): number;
    newDateFromArray(year?: number, month?: number, day?: number): any;
    newDateFromValue(value?: any): any;
    prepHeaderDate(date: Date): string;
    prepHeaderYear(date: Date): string;
    sameDay(_calendarDay: DayWithMetadata, _comparator: Date): boolean;
    year(date: Date): number;
    weekdays(): string[];
    months(): string[];
    private handleMonthAdjustment;
    prepDateStringOutput(input: any): string;
    processDateInput(input: any): Date;
}
export declare function getMomentDateAdapter(MOMENT_: any, locale?: string, timezone?: string): MomentDateAdapter;
