import { DayWithMetadata } from '../interfaces/DayWithMetadata';
import { DateRangeValidationParams } from '../interfaces/DateRangeValidationParams';
import { DateAdapter } from '../services/date-picker.service';
export declare class UTCDateAdapter implements DateAdapter<Date> {
    private _locale?;
    private readonly languageCode;
    constructor(_locale?: string);
    dayOfFirst(year: number, month: number): number;
    daysInMonth(year: number, month: number): number;
    isDisabled(evalDate: Date, dateRangeParams: DateRangeValidationParams): boolean;
    getMonthInfo(year: number, month: number): Date;
    month(date: Date): number;
    newDateFromArray(year?: number, month?: number, day?: number): Date;
    newDateFromValue(value?: any): Date;
    prepHeaderDate(date: Date): string;
    prepHeaderYear(date: Date): string;
    sameDay(_calendarDay: DayWithMetadata, _comparator: Date): boolean;
    year(date: Date): number;
    weekdays(): string[];
    months(): string[];
    prepDateStringOutput(input: Date): string;
    processDateInput(input: Date | string): Date;
    private addTimezoneOffset;
    private getZerodDate;
}
