import { ChangeDetectorRef, ElementRef, OnDestroy, ViewContainerRef } from '@angular/core';
import { ColumnDefinition, RowData } from '@anjuna/core';
export interface RowContext {
    $implicit: RowData;
    column?: ColumnDefinition;
    index: number;
}
export declare class AnjTable implements OnDestroy {
    private changeRef;
    private viewRef;
    private templates;
    element: HTMLAnjTableElement;
    private outletRows;
    private static rowContext;
    constructor(changeRef: ChangeDetectorRef, viewRef: ViewContainerRef, elRef: ElementRef);
    ngOnDestroy(): void;
    cellTemplate(cell: HTMLElement, offset: string, col: ColumnDefinition, row: RowData, rowIndex: number): void;
    fromTemplate(templateName: string, targetEl: HTMLElement, row: RowData, rowIndex: number): void;
    private createOutlet;
    private createTemplate;
    private updateContext;
    private updateOutlet;
}
